package Cpanel::Config::ConfigObj::Driver::JetBackup::META;

use strict;

use parent qw(Cpanel::Config::ConfigObj::Interface::Config::Version::v1);

our $VERSION = 1.1;

use Cpanel::Config::ConfigObj::Driver::JetBackup ();

sub meta_version {
    return 1;
}

sub get_driver_name {
    return 'JetBackup_driver';
}

sub content {
    my ($locale_handle) = @_;

    my $content = {
        'vendor' => 'JetApps',
        'url'    => 'www.jetapps.com',
        'name'   => {
            'short'  => 'JetBackup Driver',
            'long'   => 'JetBackup Driver',
            'driver' => get_driver_name(),
        },
        'since'    => 'cPanel 11.38.1',
        'abstract' => "A JetBackup driver",
        'version'  => $Cpanel::Config::ConfigObj::Driver::JetBackup::VERSION,
    };

    if ($locale_handle) {
        $content->{'abstract'} = $locale_handle->maketext("JetBackup driver");
    }

    return $content;
}

sub showcase {
    return;
}
1;
