'use strict';

define([
	'app',
	'libraries/consts'
	], function(app, CONSTS) {

	app.controller('accountFilterManagePopup',
		["$uibModalInstance", "$uibModal", "$routeParams", "$rootScope", "$scope", "SweetAlert", "jetapi", "meta",
			function($uibModalInstance, $uibModal, $routeParams, $rootScope, $scope, SweetAlert, jetapi, meta) {

				$scope.popup = true;

				$routeParams.id = null;

				$scope.status = undefined;

				$scope.details = {
					name: ''
				};

				$scope.saveData = {
					name: '',
					type: CONSTS.ACCOUNT_FILTER_TYPE_ACCOUNT,
					list: [],
					condition: CONSTS.ACCOUNT_FILTER_CONDITION_INCLUDE
				};

				$scope.$on('filterResponse', function (event, response) {

					if(response.success)
					{
						jetapi.getAccountFilterGroup({ _id: response.data.group_id }, function(details) {

							if(details.success)
							{
								SweetAlert.swal($scope.LANG.t("Success!"), response.message, "success");
								$uibModalInstance.close(details.data);
								return;
							}

							$scope.status = {
								message: details.message,
								type: "danger",
								closeable: false,
								ttl: 10000
							};
						});
						return;
					}

					$scope.status = {
						message: response.message,
						type: "danger",
						closeable: false,
						ttl: 10000
					};
				});

				$scope.ok = function () {
					$rootScope.$broadcast('createFilter');
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss();
				};
	}]);

});