'use strict';

define([
	'app',
	'libraries/permissions'
	], function(app, PERMISSIONS) {
	app.controller("agreement",
		["$rootScope", "$scope", "$uibModal", "$location", "$timeout", "jetapi", "meta", "filter", "SweetAlert", "PermPermissionStore",
			function ($rootScope, $scope, $uibModal, $location, $timeout, jetapi, meta, filter, SweetAlert, PermPermissionStore) {

				$scope.currYear = new Date().getYear() + 1900;


				$scope.setAgree = function () {

					jetapi.approveAgreement({}, function(response) {
						if(response.success) {

							window.PAGE.system.agreement = false;
							PERMISSIONS._init();

							for(var i in PERMISSIONS) {
								if(!/^can/.test(i) && !/^is/.test(i) && !/^has/.test(i)) continue;
								PermPermissionStore.definePermission(i, function(name) { return PERMISSIONS[name]; });
							}

							$location.path('/');
							return;
						}

						SweetAlert.error($scope.LANG.t("Error!"), response.message);
					});
				}
			}
		]
	);
});