'use strict';

define([
	'app',
	], function(app) {

	app.controller('destinationsSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "destinations",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, destinations) {

				$scope.loading = false;
				$scope.destinations = [];

				$scope.fetchDestinations = function () {

					$scope.loading = true;

					jetapi.listDestinations({ sort: { name: 1 } }, function (response) {

						for (var i = 0; i < response.data.destinations.length; i++) {
							if(!response.data.destinations[i].backup_destination) continue;
							response.data.destinations[i].checked = destinations !== undefined && destinations.length ? destinations.indexOf(response.data.destinations[i]._id) >= 0 : false;
							$scope.destinations.push(response.data.destinations[i]);
						}

						$scope.loading = false;

					});
				};

				$timeout($scope.fetchDestinations());

				$scope.ok = function () {

					var selected = [];
					for (var i = 0; i < $scope.destinations.length; i++) {
						if($scope.destinations[i].checked) selected.push($scope.destinations[i]._id);
					}
					$uibModalInstance.close( selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});