'use strict';

define([
	'app',
	], function(app) {
	app.controller("disasterRecoveryRestoreDR",
		["$rootScope", "$scope", "$routeParams", "$uibModal", "$location", "$timeout", "jetapi", "meta", "utils", "SweetAlert",
			function ($rootScope, $scope, $routeParams, $uibModal, $location, $timeout, jetapi, meta, utils, SweetAlert) {

				$scope.restore = function(_id, privateKey) {

					var args = { _id: _id };
					if(privateKey !== undefined) args.private_key = privateKey;

					jetapi.restoreDisasterRecovery(args, function(response) {

						if(!response.success) {
							$scope.$emit("error", response.message);
							return;
						}

						var params = {};
						if(privateKey !== undefined) params.private_key = privateKey;

						$scope.$emit("commitNextStep", params);
					});
				};

				$scope.$on('nextStep', function() {

					var backup = { _id: $scope.details.drbackup };

					for(var i = 0; i < $scope.details.drbackups.length; i++) {
						if(backup._id === $scope.details.drbackups[i]._id) {
							backup = $scope.details.drbackups[i];
							break;
						}
					}

					if(backup.encrypted) {

						$scope.privateKeyUIB = $uibModal.open({
							animation: true,
							scope: $scope,
							ariaLabelledBy: 'modal-title',
							ariaDescribedBy: 'modal-body',
							templateUrl: 'templates/jetbackup/app/views/privateKeySelection.ptt'
						});

						$scope.privateKeyUIB.result.then(function(privateKey) {

							if(!privateKey) {
								$scope.$emit("error", $scope.LANG.t("You must provide root master key"));
								return;
							}

							$scope.restore(backup._id, privateKey);
						}, function() {
							$scope.$emit("error", $scope.LANG.t("You must provide root master key"));
						});

					} else {
						$scope.restore(backup._id);
					}

				});
	}]);
});