'use strict';

define([
	'app',
	'libraries/permissions'
	], function(app, PERMISSIONS) {
	app.controller("showcase",
		["$rootScope", "$scope", "$controller", "$q", "$location", "$timeout", "jetapi", "meta", "SweetAlert", "PermPermissionStore",
			function ($rootScope, $scope, $controller, $q, $location, $timeout, jetapi, meta, SweetAlert, PermPermissionStore) {

				var showcase = window.PAGE.showcase;
				$scope.status = undefined;

				if(!showcase.total_unapproved) $location.path('/');

				$scope.features = {};
				for (var i = 0 ; i < showcase.total; i++) {
					$scope.features[showcase.features[i].order + '_' + showcase.features[i].feature] = showcase.features[i];
					//require(['/templates/jetbackup/app/showcase/' + showcase.features[i].order + '_' + showcase.features[i].feature + '/controller.js']);
				}

				$scope.checkFeatures = function() {

					for(var i in $scope.features) {
						if(!$scope.features[i].approved) return false;
					}

					window.PAGE.showcase.total_unapproved = 0;
					PERMISSIONS._init();

					for(var i in PERMISSIONS) {
						if(!/^can/.test(i) && !/^is/.test(i) && !/^has/.test(i)) continue;
						PermPermissionStore.definePermission(i, function(name) { return PERMISSIONS[name]; });
					}

					$location.path('/');
				};

				$scope.setStatus = function(message) {
					if($scope.status === undefined) {
						$scope.status = {
							message: message,
							type: "danger",
							closeable: false,
							ttl: 10000
						};
					} else {
						$scope.status.message += "<br />" + message;
					}
				};

				$rootScope.$on('approve', function(event, _id) {

					jetapi.approveShowcase({ _id: _id }, function (response) {
						if(!response.success) {
							$scope.setStatus(response.message);
							return;
						}

						$scope.features[_id].approved = true;
						$scope.checkFeatures();
					});
				});

				$rootScope.$on('error', function(event, error) { $scope.setStatus(error); });

				$scope.saveChanges = function() {
					$scope.status = undefined;
					$rootScope.$broadcast('save');
				};
			}
		]
	);
});