'use strict';

define([
	'app'
], function (app) {
	app.controller("localFields",
		["$rootScope", "$scope", "$location", "$timeout", "$uibModalInstance", "jetapi", "destinationParams",
			function ($rootScope, $scope, $location, $timeout, $uibModalInstance, jetapi, destinationParams) {


				$scope.destinationParams = destinationParams;

				$scope.error = false;
				$scope.saving = false;
				$scope.message = '';

				var createLocalDestination = function () {
					$scope.saving = true;
					$scope.destinationParams['type'] = 'Local';
					$scope.destinationParams['name'] = $scope.destinationParams['destinationname'];

					jetapi.manageDestination($scope.destinationParams, function (response) {
							$scope.error = !response.success;
							$scope.message = response.message;
							$scope.saving = false;
							if(response.success) $uibModalInstance.close(response.data);
						}
					);
				};


				$scope.submit = function () {
					$scope.error = false;
					createLocalDestination();
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss({});
				};


			}
		]
	);
});