'use strict';

define([
	'app',
], function (app) {

	app.directive("inputSelector", ["$sce", "$compile", "lang",
		function($sce, $compile, lang) {

			return {
				link: function(scope, element, attrs, ngModel, transclude) {

					if(!scope.selectorRates) return;
					scope.selectorRates.push({ label: lang.t("Custom"), value: '' });

					scope.lang = lang;
					scope.hidden = false;

					var x = transclude();

					// get only the non
					var elems = [];
					for(var i = 0; i < x.length; i++) {
						var elem = angular.element(x[i]);
						if(elem.html() !== undefined) elems.push(elem);
					}

					element.find('p').replaceWith(x);

					scope.curr = 0;
					scope.$watch('ngModel', function () {

						if(ngModel.$viewValue === undefined || scope.curr === '') return;

						for(var i = 0; i < scope.selectorRates.length; i++) {
							if(ngModel.$viewValue == scope.selectorRates[i].value) {
								scope.curr = ngModel.$viewValue;
								return;
							}
						}

						scope.curr = '';

					});

					scope.$watch("curr", function(newVal ,oldVal) {

						if(newVal !== '') {
							for(var i = 0; i < elems.length; i++) elems[i].css( "display", "none");
							ngModel.$setViewValue(scope.curr);
							scope.hidden = true;
							return;
						}

						for(var i = 0; i < elems.length; i++) elems[i].css( "display", "");
						scope.hidden = false;
					});
				},

				restrict: "E", //The binding type
				replace:true,
				transclude: true,
				require: "ngModel",
				scope: {
					selectorRates: "=selector",
					model: '=',
					preLabel: '@',
					postLabel: '@',
					ngModel: '='
				},
				template:
					'<div class="input-group">' +
						'<span ng-if="preLabel" class="input-group-addon">{{ lang.t(preLabel) }}</span>' +
						'<select class="form-control" data-ng-options="max_rate.value as max_rate.label for max_rate in selectorRates" data-ng-model="curr"></select>' +
						'<span ng-hide="hidden" class="input-group-addon"><label style="font-weight: normal;">{{ lang.t("Custom") }}</label></span>' +
						'<p></p>' + // The p will be replaced with the transclude.
						'<span ng-if="postLabel" class="input-group-addon">{{ lang.t(postLabel) }}</span>' +
					'</div>'
			};
		}
	]);
});