'use strict';

define([], function() {
	var PERMISSIONS = function() { this._init(); };

	PERMISSIONS.prototype = {
		_permissions: {},
		_account: '',
		_licenseText: '',
		_init: function () {

			this._permissions = window.PAGE.permissions;
			this._account = window.PAGE.account;


			this.hasAllPrivileges = this._can(2);
			this.isRoot = this._account === 'root' || this.hasAllPrivileges;

			this.isShowcase = this.isRoot && window.PAGE.showcase.total_unapproved;
			this.isLicenseIssue = window.PAGE.system.licenseIssue;
			this.isDisasterRecovery = window.PAGE.system.drMode;
			this.isAgreement = window.PAGE.system.agreement;
			this.isFullscreen = this.isLicenseIssue || this.isDisasterRecovery || this.isShowcase || this.isAgreement;


			// WHM Permissions
			this.canViewAccounts = this._can(0);
			this.canManageAccounts = this._can(1);
			this.canViewBackups = this._can(3);
			this.canAddBackupNotes = this._can(113);
			this.canViewFullBackups = this._can(4);
			this.canRestoreFullBackups = this._can(5);
			this.canDownloadFullBackups = this._can(6);
			this.canViewConfigBackups = this._can(110);
			this.canRestoreConfigBackups = this._can(111);
			this.canDownloadConfigBackups = this._can(112);
			this.canViewFileBackups = this._can(7);
			this.canRestoreFileBackups = this._can(8);
			this.canDownloadFileBackups = this._can(9);
			this.canViewCronBackups = this._can(10);
			this.canRestoreCronBackups = this._can(11);
			this.canDownloadCronBackups = this._can(12);
			this.canViewEmailBackups = this._can(13);
			this.canRestoreEmailBackups = this._can(14);
			this.canDownloadEmailBackups = this._can(15);
			this.canViewDatabaseBackups = this._can(16);
			this.canRestoreDatabaseBackups = this._can(17);
			this.canDownloadDatabaseBackups = this._can(18);
			this.canViewSSLBackups = this._can(19);
			this.canRestoreSSLBackups = this._can(20);
			this.canDownloadSSLBackups = this._can(21);
			this.canViewDNSZoneBackups = this._can(97);
			this.canRestoreDNSZoneBackups = this._can(98);
			this.canDownloadDNSZoneBackups = this._can(99);
			this.canViewDirectoriesBackups = this._can(31);
			//this.canRestoreDirectoriesBackups = this._can(32);
			this.canDownloadDirectoriesBackups = this._can(33);
			this.canLockBackups = this._can(109);
			// this.canViewOrphanBackups = this._can(22);
			// this.canRestoreOrphanBackups = this._can(23);
			// this.canDownloadOrphanBackups = this._can(24);
			this.canViewAccountFilters = this._can(25);
			this.canManageAccountFilters = this._can(26);
			this.canViewBackupJobs = this._can(27);
			this.canManageBackupJobs = this._can(28);
			this.canViewSnapshots = this._can(29);
			this.canManageSnapshots = this._can(30);
			this.canViewQueue = this._can(114);
			this.canViewCloneJobs = this._can(41);
			this.canManageCloneJobs = this._can(42);
			this.canViewDestinations = this._can(45);
			this.canManageDestinations = this._can(46);
			this.canHideDestinations = this._can(48);
			this.canViewPermissions = this._can(53);
			this.canViewWHMPermissions = this._can(54);
			this.canManageWHMPermissions = this._can(55);
			this.canViewWHMUserPermissions = this._can(56);
			this.canManageWHMUserPermissions = this._can(57);
			this.canViewCpanelPermissions = this._can(58);
			this.canManageCpanelPermissions = this._can(59);
			this.canViewCpanelUserPermissions = this._can(60);
			this.canManageCpanelUserPermissions = this._can(61);
			this.canViewLogs = this._can(62);
			this.canViewSystemLogs = this._can(63);
			this.canManageSystemLogs = this._can(71);
			this.canViewRestoreLogs = this._can(64);
			this.canManageRestoreLogs = this._can(72);
			this.canViewBackupLogs = this._can(65);
			this.canManageBackupLogs = this._can(73);
			this.canViewSnapshotLogs = this._can(66);
			this.canManageSnapshotLogs = this._can(74);
			this.canViewCloneLogs = this._can(67);
			this.canManageCloneLogs = this._can(75);
			// this.canViewHookLogs = this._can(68);
			// this.canManageHookLogs = this._can(76);
			this.canViewDownloadLogs = this._can(69);
			this.canManageDownloadLogs = this._can(77);
			// this.canViewNotifyLogs = this._can(70);
			// this.canManageNotifyLogs = this._can(78);
			/*
			this.canViewSettings = this._can(79);
			this.canViewGeneralSettings = this._can(80);
			this.canManageGeneralSettings = this._can(87);
			this.canViewPerformanceSettings = this._can(81);
			this.canManagePerformanceSettings = this._can(88);
			this.canViewBinaryLocationsSettings = this._can(82);
			this.canManageBinaryLocationsSettings = this._can(89);
			this.canViewRestoreSettings = this._can(83);
			this.canManageRestoreSettings = this._can(90);
			this.canViewSnapshotsSettings = this._can(84);
			this.canManageSnapshotsSettings = this._can(91);
			this.canViewNotificationsSettings = this._can(86);
			this.canManageNotificationsSettings = this._can(93);
			this.canViewResourceSettings = this._can(103);
			this.canManageResourceSettings = this._can(104);
			*/
			this.canViewAlerts = this._can(102);
			this.canManageAlerts = this._can(106);
			this.canViewHooks = this._can(49);
			this.canManageHooks = this._can(50);
			//this.canExport = this._can(95);
			//this.canImport = this._can(96);

			this.canViewSchedules = this.canViewBackupJobs || this.canViewCloneJobs || this.canViewDestinations;
			this.canManageSchedules = this.canManageBackupJobs || this.canManageCloneJobs || this.canManageDestinations;

			// custom permissions
			this.canViewAccountsBackups = this.canViewFullBackups || this.canViewConfigBackups || this.canViewFileBackups || this.canViewCronBackups || this.canViewEmailBackups || this.canViewDatabaseBackups || this.canViewSSLBackups || this.canViewDNSZoneBackups;
			this.canViewAnyBackups = this.canViewAccountsBackups || this.canViewDirectoriesBackups;
			this.canManageSnapshotsAndClone = this.canManageSnapshots || this.canManageAccounts;
			//this.canViewAnySettings = this.canViewGeneralSettings || this.canViewPerformanceSettings || this.canViewBinaryLocationsSettings || this.canViewRestoreSettings || this.canViewSnapshotsSettings || this.canViewNotificationsSettings || this.canViewResourceSettings;
			this.canViewAnyPermissions = this.canViewWHMPermissions || this.canViewWHMUserPermissions || this.canViewCpanelPermissions || this.canViewCpanelUserPermissions;
			this.canViewFileManage = this.canViewFileBackups || this.canManageDestinations;
			this.canManageLogs = this.canManageBackupLogs || this.canManageCloneLogs || this.canManageDownloadLogs || this.canManageRestoreLogs || this.canManageSnapshotLogs || this.canManageSystemLogs;

			this.canManageBackupJobsAsRoot = this.isRoot;
			this.canManageDestinationsAsRoot = this.isRoot;

		},
		_can: function (permission) {
			return !this.isLicenseIssue && !this.isDisasterRecovery && !this.isShowcase && !this.isAgreement && !!this._permissions[permission];
		},
		_get: function(section, permission) {

			var permissions = {
				whm: {
					2: { name: 'Reseller has all privileges (same as root)', section: 2},

					0: { name: 'Reseller can view Accounts', section: 0},
					1: { name: 'Reseller can manage Accounts', section: 0},

					3: { name: 'Reseller can view Backups', section: 3},
					109: { name: 'Reseller can Lock Backups', section: 3},
					4: { name: 'Reseller can view Full accounts Backups', section: 3},
					5: { name: 'Reseller can restore accounts from Full Backups', section: 3},
					6: { name: 'Reseller can download accounts Full Backups', section: 3},
					110: { name: 'Reseller can view accounts cPanel Config Backups', section: 3},
					111: { name: 'Reseller can restore accounts from cPanel Config Backups', section: 3},
					112: { name: 'Reseller can download accounts cPanel Config Backups', section: 3},
					7: { name: 'Reseller can view File Backups', section: 3},
					8: { name: 'Reseller can restore from File Backups', section: 3},
					9: { name: 'Reseller can download File Backups', section: 3},
					10: { name: 'Reseller can view Cron Job Backups', section: 3},
					11: { name: 'Reseller can restore from Cron Job Backups', section: 3},
					12: { name: 'Reseller can download Cron Job Backups', section: 3},
					13: { name: 'Reseller can view Email Account Backups', section: 3},
					14: { name: 'Reseller can restore from Email Account Backups', section: 3},
					15: { name: 'Reseller can download Email Account Backups', section: 3},
					16: { name: 'Reseller can view Database Backups', section: 3},
					17: { name: 'Reseller can restore from Database Backups', section: 3},
					18: { name: 'Reseller can download Database Backups', section: 3},
					19: { name: 'Reseller can view SSL Certificate Backups', section: 3},
					20: { name: 'Reseller can restore from SSL Certificate Backups', section: 3},
					21: { name: 'Reseller can download SSL Certificate Backups', section: 3},
					97: { name: 'Reseller can view DNS Zone Backups', section: 3},
					98: { name: 'Reseller can restore from DNS Zone Backups', section: 3},
					99: { name: 'Reseller can download DNS Zone Backups', section: 3},
					22: { name: 'Reseller can view Orphan Backups', section: 3},
					23: { name: 'Reseller can restore Orphan Backups', section: 3},
					24: { name: 'Reseller can download Orphan Backups', section: 3},
					31: { name: 'Reseller can view Directories Backups', section: 3},
					//32: { name: 'Reseller can restore Directories Backups', section: 3},
					33: { name: 'Reseller can download Directories Backups', section: 3},
					113: { name: 'Reseller can add notes on Backups', section: 3},

					45: { name: 'Reseller can view Destinations', section: 45},
					46: { name: 'Reseller can manage Destinations', section: 45},
					//47: { name: 'Reseller can set Destinations Disaster Recovery', section: 45},
					48: { name: 'Reseller can hide Destinations', section: 45},

					//43: { name: 'Reseller can view Schedules', section: 43},
					//44: { name: 'Reseller can manage Schedules', section: 43},

					25: { name: 'Reseller can view Account Filters', section: 25},
					26: { name: 'Reseller can manage Account Filters', section: 25},

					27: { name: 'Reseller can view Backup Jobs', section: 27},
					28: { name: 'Reseller can manage Backup Jobs', section: 27},

					41: { name: 'Reseller can view Clone Jobs', section: 41},
					42: { name: 'Reseller can manage Clone Jobs', section: 41},

					29: { name: 'Reseller can view Snapshots', section: 29},
					30: { name: 'Reseller can manage Snapshots', section: 29},

					102: { name: 'Reseller can view Alerts', section: 102},
					106: { name: 'Reseller can manage Alerts', section: 102},

					49: { name: 'Reseller can view Hooks', section: 49},
					50: { name: 'Reseller can manage Hooks', section: 49},

					114: { name: 'Reseller can view Queues', section: 114},

					62: { name: 'Reseller can view Logs', section: 62},
					63: { name: 'Reseller can view System Logs', section: 62},
					71: { name: 'Reseller can manage System Logs', section: 62},
					64: { name: 'Reseller can view Restore Logs', section: 62},
					72: { name: 'Reseller can manage Restore Logs', section: 62},
					65: { name: 'Reseller can view Backup Logs', section: 62},
					73: { name: 'Reseller can manage Backups Logs', section: 62},
					66: { name: 'Reseller can view Snapshots Logs', section: 62},
					74: { name: 'Reseller can manage Snapshots Logs', section: 62},
					67: { name: 'Reseller can view Clone Logs', section: 62},
					75: { name: 'Reseller can manage Clone Logs', section: 62},
					// 68: { name: 'Reseller can view Hook Logs', section: 62},
					// 76: { name: 'Reseller can manage Hook Logs', section: 62},
					69: { name: 'Reseller can view Downloads Logs', section: 62},
					77: { name: 'Reseller can manage Downloads Logs', section: 62},
					// 70: { name: 'Reseller can view Notify Logs', section: 62},
					// 78: { name: 'Reseller can manage Notify Logs', section: 62},

					53: { name: 'Reseller can view Permission', section: 53},
					54: { name: 'Reseller can view Global WHM Permissions', section: 53},
					55: { name: 'Reseller can manage Global WHM Permissions', section: 53},
					56: { name: 'Reseller can view Specific WHM Reseller Permissions', section: 53},
					57: { name: 'Reseller can manage Specific WHM Reseller Permissions', section: 53},
					58: { name: 'Reseller can view Global cPanel Permissions', section: 53},
					59: { name: 'Reseller can manage Global cPanel Permissions', section: 53},
					60: { name: 'Reseller can view Specific cPanel User Permissions', section: 53},
					61: { name: 'Reseller can manage Specific cPanel User Permissions', section: 53}

					/*
					79: { name: 'Reseller can view Settings', section: 79},
					80: { name: 'Reseller can view General Settings', section: 79},
					87: { name: 'Reseller can manage General Settings', section: 79},
					81: { name: 'Reseller can view Performance Settings', section: 79},
					88: { name: 'Reseller can manage Performance Settings', section: 79},
					82: { name: 'Reseller can view Binary Locations Settings', section: 79},
					89: { name: 'Reseller can manage Binary Locations Settings', section: 79},
					83: { name: 'Reseller can view Restore Settings', section: 79},
					90: { name: 'Reseller can manage Restore Settings', section: 79},
					84: { name: 'Reseller can view Snapshots Settings', section: 79},
					91: { name: 'Reseller can manage Snapshots Settings', section: 79},
					86: { name: 'Reseller can view Notification Settings', section: 79},
					93: { name: 'Reseller can manage Notification Settings', section: 79},
					103: { name: 'Reseller can view Resource Settings', section: 79},
					104: { name: 'Reseller can manage Resource Settings', section: 79}
					*/
				},
				cpanel: {
					1: { name: 'User can view Backups', section: 1},
					2: { name: 'User can view Full account Backups', section: 1},
					3: { name: 'User can restore account from Full Backups', section: 1},
					4: { name: 'User can download account Full Backups', section: 1},
					5: { name: 'User can view File account Backups', section: 1},
					6: { name: 'User can restore account from File Backups', section: 1},
					7: { name: 'User can download account File Backups', section: 1},
					8: { name: 'User can view Cron Job account Backups', section: 1},
					9: { name: 'User can restore account from Cron Job Backups', section: 1},
					10: { name: 'User can download account Cron Job Backups', section: 1},
					11: { name: 'User can view Email account Backups', section: 1},
					12: { name: 'User can restore account from Email Backups', section: 1},
					13: { name: 'User can download account Email Backups', section: 1},
					14: { name: 'User can view Database account Backups', section: 1},
					15: { name: 'User can restore account from Database Backups', section: 1},
					16: { name: 'User can download account Database Backups', section: 1},
					17: { name: 'User can view SSL Certificate account Backups', section: 1},
					18: { name: 'User can restore account from SSL Certificate Backups', section: 1},
					19: { name: 'User can download account SSL Certificate Backups', section: 1},
					20: { name: 'User can view DNS Zone account Backups', section: 1},
					21: { name: 'User can restore account from DNS Zone Backups', section: 1},
					22: { name: 'User can download account DNS Zone Backups', section: 1},
					32: { name: 'User can view cPanel Config account Backups', section: 1},
					33: { name: 'User can restore account from cPanel Config Backups', section: 1},
					34: { name: 'User can download account cPanel Config Backups', section: 1},
					35: { name: 'User can add notes on Backups', section: 1},

					27: { name: 'User can view Snapshots', section: 27},
					28: { name: 'User can manage Snapshots', section: 27},

					29: { name: 'User can view Settings', section: 29},
					30: { name: 'User can manage Settings', section: 29}

					//31: { name: 'User can view Queues', section: 31}
				}
			};

			return permissions[section][permission] !== undefined ? permissions[section][permission] : null;
		}
	};

	return new PERMISSIONS();
});