'use strict';

define([
		'app'
	], function (app) {
		app.controller('sslBackups',
			['$scope', '$interval', '$routeParams', 'meta', 'lang', 'backup', 'jetapi', 'consts', '$timeout',
				function ($scope, $interval, $routeParams, meta, lang, backup, jetapi, consts, $timeout) {

					$scope.backupType = consts.BACKUP_TYPE_SSL_CERTIFICATES;


					$scope.backups = [];
					$scope.loading = false;
					$scope.actionModule= '';
					$scope.config = PAGE.config;
					$scope.refreshIntervalRate = 3000;
					$scope.interval = null;

					var metaSSLBackups = meta.new('sslBackups');
					$scope.meta = metaSSLBackups;
					$scope.metaData = metaSSLBackups.getData();

					metaSSLBackups.setSortReverse(false);
					if(!metaSSLBackups.getSortBy()) metaSSLBackups.setSortBy("name");
					if(!metaSSLBackups.getSortDirection()) metaSSLBackups.setSortDirection("asc");
					metaSSLBackups.setSortFields(["name", "created", "size", "location"]);
					metaSSLBackups.setTotalItems($scope.backups.length);

					$scope.backupHandler = new backup($scope.backupType, metaSSLBackups);

					$scope.fetchData = function() {
						$scope.loading = true;

						$scope.backups = [];
						$scope.backupHandler.loadList(function(response) {

							metaSSLBackups.setTotalItems(response.data.total);
							metaSSLBackups.calculate(response.data.backups);
							$scope.backups = response.data.backups;
							$scope.loading = false;

							$scope.backupHandler.checkStatus($scope);
							$scope.backupHandler.setList($scope.backups);
						});
					};

					$scope.checkStatus = function () {
						if(!$scope.backupHandler.hasQueueItem) return;
						$scope.interval = $interval(function() {
							if(!$scope.backupHandler.hasQueueItem()){
								$interval.cancel($scope.interval);
								$scope.interval = null;
								return;
							}
							$scope.backupHandler.checkStatus($scope);
						}, $scope.refreshIntervalRate);
					};

					$timeout(function () {
						$scope.fetchData();
						$scope.checkStatus();
					}());

					$scope.$on("$destroy", function() {
						if($scope.interval !== undefined) {
							$interval.cancel($scope.interval);
							$scope.interval = null;
						}
					});
				}
			]
		);
	}
);